<?php
require_once(dirname(__FILE__).'/paymentAbstract.php');

class MicropaymentNotifyModuleFrontController extends MicropaymentPaymentAbstractModuleFrontController
{
  protected $orderConfirmationUrl = 'index.php?controller=order-confirmation';

//  public function initContent()
//  {
//    //parent::initContent();
//  }

  public function postProcess()
  {
    $transactionId  = Tools::getValue('transactionId');
    $cartId         = Tools::getValue('trxid');
    $orderId        = Tools::getValue('orderid');
    $sessId         = Tools::getValue('sessionId');
    $authId         = Tools::getValue('auth');
    $paytoken       = Tools::getValue('paytoken');
    $currency       = $this->context->currency;
    $amount         = Tools::getValue('amount');
    //$cart           = $this->context->cart;
    $cart           = new Cart($cartId);
    $customer       = new Customer($cart->id_customer);
    $actPM          = $this->paymentMethod;

    require_once(dirname(__FILE__).'/../../micropayment.php');
    $mcp = new micropayment();
    //echo '<pre>'.print_r($mcp,true).'</pre>';
    $cfg = $mcp->getCfg();
    //echo '<pre>'.print_r($cfg,true).'</pre>';
    $this->mcpay->setConfig($cfg);
    //echo '<pre>'.print_r($this->mcpay,true).'</pre>';

    $domain = Tools::getHttpHost(true).__PS_BASE_URI__;
    $successURL = $domain.$this->getRedirectSuccess($cartId, $customer->secure_key);
    //echo '<pre>'.print_r($domain,true).'</pre>';
    //echo '<pre>'.print_r($successURL,true).'</pre>';

    $order = new Order($orderId);

    $data = array(
      'openAmount' => (int)($order->total_paid * 100),
      'successURL' => $successURL,
      'sessionID' => $sessId,
      'shopInfo' => _PS_VERSION_,
      'pluginInfo' => $mcp->version.'<br>'.print_r($mcp->loadPluginConfig(),true),
    );
    $res = $this->mcpay->getNotification($_REQUEST, $data);
    //echo '<pre>'.print_r($res,true).'</pre>';

    if (empty($res->error)){
      switch($res->state){
        case 'paid':
          $paymentStatus = Configuration::get('MICROPAYMENT_PAYMENT_STATUS_PAID');
          $message = 'MCP AUTHID: '.$authId;

          if ($res->paidAmount > 0 && !$order->addOrderPayment($res->paidAmount/100, $this->paymentMethod, $transactionId)) {
            throw new PrestaShopException('Can\'t save Order Payment');
          }
          break;

        case 'init': // prepay
          $paymentStatus = Configuration::get('MICROPAYMENT_PAYMENT_STATUS_PENDING');
          $message = 'MCP PAYTOKEN: '.$paytoken;
          break;

        case 'part_paid':
          $paymentStatus = Configuration::get('MICROPAYMENT_PAYMENT_STATUS_PARTPAID');
          if ($res->openAmount <= 0){
            $paymentStatus = Configuration::get('MICROPAYMENT_PAYMENT_STATUS_PAID');
          }
          $message = 'MCP PAYTOKEN: '.$paytoken.' PAID: '.$res->paidAmount.' OPEN: '.$res->openAmount;
          if ($res->paidAmount > 0 && !$order->addOrderPayment($res->paidAmount/100, $this->paymentMethod, $transactionId)) {
            throw new PrestaShopException('Can\'t save Order Payment');
          }
          break;

        case 'refund':
          $paymentStatus = Configuration::get('MICROPAYMENT_PAYMENT_STATUS_REFUND');
          $message = 'MCP AUTHID: '.$authId.' REFUND: '.$res->refundAmount.' OPEN: '.$res->openAmount;
          break;
        case 'part_refund':
          $paymentStatus = Configuration::get('MICROPAYMENT_PAYMENT_STATUS_PARTREFUND');
          $message = 'MCP AUTHID: '.$authId.' REFUND: '.$res->refundAmount.' OPEN: '.$res->openAmount;
          break;
      }

      $id_employee = isset($this->context->employee->id) ? (int)$this->context->employee->id : 0;
      $order->setCurrentState($paymentStatus, $id_employee);
      $order->note.= "\r\n".date('Y-m-d H:i:s').' '.$message;
      $order->save();

      // for older versions of presta
      $msg = new Message();
      $msg->message = $message;
      $msg->id_cart = (int) $order->id_cart;
      $msg->id_customer = (int) ($order->id_customer);
      $msg->id_order = (int) $orderId;
      $msg->private = 1;
      $msg->add();
    }
    echo $res->mpStatus;
    exit();
    
    //$this->context->cart->orderExists();
  }

  protected function getRedirectSuccess($cartId, $secure_key)
  {
    // https://php74.docker:8081/presta/index.php?controller=order-confirmation&id_cart=6&id_module=69&key=fe2c3403042dd794e3ef394981867e85
    return 
      $this->orderConfirmationUrl.
      '&id_cart='.$cartId.
      '&id_module='.(int)$this->module->id.
      '&key='.$secure_key
    ;
  }
}