<?php
use \mcpay as mcpay;

class MicropaymentPaymentAbstractModuleFrontController extends ModuleFrontController
{
  protected $paymentMethod       = '';
  protected $templateName        = 'module:micropayment/views/templates/front/micropayment_form.tpl';
  public    $ssl                 = TRUE;
  public    $display_column_left = FALSE;

  public function __construct()
  {
    parent::__construct();
    if (!defined('MCPAY_BASE_PATH')) {
      define('MCPAY_BASE_PATH', dirname(__FILE__).'/vendor/mcpay/');
    }
    require_once(MCPAY_BASE_PATH.'classes/class.mcpay.php');
    $this->mcpay = new mcpay();
    //echo '<pre>'.print_r($this->mcpay,true).'</pre>';
  }

  public function initContent()
  {
    parent::initContent();

    $debug = false;

    require_once(dirname(__FILE__).'/../../micropayment.php');
    $mcp = new micropayment();
    //if ($debug) echo '<pre>'.print_r($mcp,true).'</pre>';

    if ($this->paymentMethod == 'mcp_ccard_api'){
//      echo '<pre>'.print_r($_GET,true).'</pre>';
//      echo '<pre>'.print_r($_POST,true).'</pre>';
//      echo '<pre>'.print_r($this->context,true).'</pre>';
//      exit();
      $returnMessage = 'There is an error !';
      return $this->redirectError($returnMessage);
    }

    $cart = $this->context->cart;
    $cartId = $cart->id;
    $paymentStatus = Configuration::get('MICROPAYMENT_PAYMENT_STATUS_PENDING');
    $customer    = new Customer($cart->id_customer);
    $currency    = new Currency((int)$cart->id_currency);
    $this->module->validateOrder(
      $cartId,
      $paymentStatus,
      $cart->getOrderTotal(TRUE, Cart::BOTH),
      $this->paymentMethod,
      '', //null,
      '', //array('transaction_id' => $transactionId),
      $currency->id,
      FALSE,
      $customer->secure_key
    );
    $orderId = Order::getIdByCartId($cartId);
    if ($debug) echo '<pre>OrderID: '.print_r($orderId, TRUE).'</pre>';

    $userData = $mcp->getUserData();
    if ($debug) echo '<pre>'.print_r($userData, TRUE).'</pre>';

    $langISO = $this->getLang();
    $userData['lang'] = $langISO;
    $userData['trxid'] = $cartId;
    $userData['oid'] = $orderId;
    $userData['order_id'] = $orderId;
    //$userData['respurl'] = $this->redirectError('Cancelled by user!');

    //$config     = $this->getSettings();
    $config = $mcp->loadPluginConfig();
    //echo '<pre>'.print_r($config,true).'</pre>';
    $config['MICROPAYMENT_GENERAL_TESTMODE'] = $config['MICROPAYMENT_'.strtoupper($this->paymentMethod).'_TESTMODE'];
    $config = $mcp->getCfg($config);
    if ($debug) echo '<pre>'.print_r($config,true).'</pre>';
    
    $url = $mcp->getURL($userData, $config, $this->paymentMethod);
    if ($debug) echo '<pre>'.print_r($url,true).'</pre>';

    $this->setRedirectAfter($url);
    if (!$debug) $this->redirect();
  }

  /**
   * redirectError
   *
   * @param $returnMessage
   */
  private function redirectError($returnMessage)
  {
    $this->errors[] = $returnMessage;
    $this->redirectWithNotifications(
      $this->context->link->getPageLink('order', TRUE, NULL, array('step' => '3'))
    );
  }

  /**
   * getLang
   *
   * @return array|false|string|string[]|null
   * @throws \PrestaShopDatabaseException
   * @throws \PrestaShopException
   */
  private function getLang()
  {
    $cart         = $this->context->cart;
    $language     = new Language((int)$cart->id_lang);
    $languageCode = $language->iso_code;

    return Tools::strtoupper($languageCode);
  }
}
